SystemOrganization addCategory: #Maybe!

Object subclass: #Maybe
	instanceVariableNames: ''
	classVariableNames: 'NothingSingleton'
	poolDictionaries: ''
	category: 'Maybe'!

Maybe subclass: #Just
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maybe'!

!Just class methodsFor: 'private' stamp: 'fbs 6/14/2011 18:09'!
value: anObject
	^ self new value: anObject.! !

!Just methodsFor: 'comparing' stamp: 'fbs 7/5/2011 17:58'!
= anObject
	^ anObject hasValue and: [value = anObject value]! !

!Just methodsFor: 'monad' stamp: 'fbs 6/29/2011 07:38'!
>>= aMaybeReturningUnaryBlock
	"Take my value, and evaluate the Block with it."
	^ aMaybeReturningUnaryBlock value: value! !

!Just methodsFor: 'testing' stamp: 'fbs 6/15/2011 17:24'!
hasValue
	^ true.! !

!Just methodsFor: 'applying' stamp: 'fbs 6/15/2011 17:56'!
maybe: aBlock default: anObject
	^ aBlock value: value.! !

!Just methodsFor: 'printing' stamp: 'fbs 6/15/2011 17:42'!
printOn: aStream
	aStream nextPutAll: 'Just '.
	^ value printOn: aStream.! !

!Just methodsFor: 'accessing' stamp: 'fbs 6/14/2011 18:09'!
value
	^ value! !

!Just methodsFor: 'private' stamp: 'fbs 6/14/2011 18:10'!
value: anObject
	value := anObject.! !

!Maybe class methodsFor: 'class initialization' stamp: 'fbs 6/14/2011 18:38'!
initialize
	^ NothingSingleton ifNil: [NothingSingleton := Nothing new]! !

!Maybe class methodsFor: 'instance creation' stamp: 'fbs 6/14/2011 18:38'!
nothing
	^ NothingSingleton! !

!Maybe class methodsFor: 'instance creation' stamp: 'fbs 7/5/2011 22:12'!
return
	^ [:x | Just value: x].! !

!Maybe class methodsFor: 'instance creation' stamp: 'fbs 7/5/2011 22:12'!
return: anObject
	^ self return value: anObject.! !

!Maybe class methodsFor: 'instance creation' stamp: 'fbs 6/14/2011 18:09'!
value: anObject
	^ Just value: anObject.! !

!Maybe methodsFor: 'monad' stamp: 'fbs 6/28/2011 22:26'!
>>= aUnaryBlock
	self subclassResponsibility.! !

!Maybe methodsFor: 'testing' stamp: 'fbs 6/15/2011 17:24'!
hasValue
	^ false.! !

!Maybe methodsFor: 'testing' stamp: 'fbs 6/15/2011 17:31'!
ifNothing: nothingBlock ifNotNothing: justBlock
	^ self hasValue
		ifTrue: [justBlock value]
		ifFalse: [nothingBlock value]! !

!Maybe methodsFor: 'applying' stamp: 'fbs 6/21/2011 20:20'!
maybe: aBlock default: anObject
	self subclassResponsibility! !

!Maybe methodsFor: 'accessing' stamp: 'fbs 6/14/2011 18:10'!
value
	self subclassResponsibility! !

Maybe subclass: #Nothing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Maybe'!

!Nothing methodsFor: 'monad' stamp: 'fbs 6/28/2011 22:27'!
>>= aUnaryBlock
	^ Maybe nothing.! !

!Nothing methodsFor: 'applying' stamp: 'fbs 6/15/2011 17:55'!
maybe: aBlock default: anObject
	^ anObject.! !

!Nothing methodsFor: 'printing' stamp: 'fbs 6/15/2011 17:40'!
printOn: aStream
	^ aStream nextPutAll: 'Nothing'.! !

!Nothing methodsFor: 'accessing' stamp: 'fbs 6/14/2011 18:10'!
value
	Error signal: 'None has no value'.! !
Maybe initialize!
